<template lang="pug">
  div
    .form-horizontal
      .divider.text-center(data-content="Server Parameters")
      .form-group
        .col-3.col-sm-12
          label {{ $t('instance name') }}
        .col-9.col-sm-12
          z-input(v-validate="'max:30'" name="profileName" placeholder="OLKi" v-model="general.general_SiteTitle" maxlength="30")
      .form-group
        .col-3.col-sm-12
          label {{ $t('instance subjects') }}
        .col-9.col-sm-12
          multiselect(
            v-model="subjectsSelected",
            track-by="name",
            label="name",
            :tag-placeholder="$t('add new tag')",
            :placeholder="$t('search new tag')",
            :multiple="true",
            :searchable="true"
            :loading="isLoading"
            :internal-search="false"
            :options="subjectsAndTypes"
            :allow-empty="true"
            :clear-on-select="false"
            :close-on-select="false"
            :options-limit="20"
            :limit="5"
            @search-change="asyncFindTag"
          )
            template(slot="option", slot-scope="props")
              strong.option__title {{ props.option.name }} #[br]
              span.option__small {{ props.option.description }}
          .text-subtitle.text-gray.text-left Leave empty if your instance welcomes all categories and subjects of works. Otherwise, display your focus on certain matters or forms, allowing users and admins to quickly understand the nature of your content.
      .form-group
        .col-3.col-sm-12
          label {{ $t('instance description') }}
        .col-9.col-sm-12
          z-input(type="textarea" v-model="general.general_SiteDescription" v-validate="'max:200'" data-vv-as="field" name="profileDescription" maxlength="200" counter)
      .form-group
        .col-3.col-sm-12
        .col-9.col-sm-12
          z-switch(v-model="general.general_RegistrationAllowed") {{ $t('registerSwitchDescriptionForAdmin') }}
      .form-group
        .col-3.col-sm-12
          label {{ $t('termsAgreedRules') | capitalize }}
        .col-9.col-sm-12
          z-input(type="textarea" v-model="general.general_SiteRules" v-validate="'max:2000'" data-vv-as="field" name="profileDescription" maxlength="2000" counter)
      .form-group
        .col-3.col-sm-12
          label {{ $t('termsAgreedTOS') | capitalize }}
        .col-9.col-sm-12
          z-input(type="textarea" v-model="general.general_SiteTos" v-validate="'max:2000'" data-vv-as="field" name="profileDescription" maxlength="2000" counter)
      fieldset(:disabled="true")
        .form-group
          .col-3.clom-sm-12
            label {{ $tc('administrator', 1) }}
          .col-9.col-sm-12
            z-input(v-validate="'email'" name="adminEmail" placeholder="Admin email")
            z-switch Show admin contact form
            z-switch
              .label-text Show admin profile
              .label-hint If the email provided corresponds to a local administrator, their profile will be displayed.
      fieldset(:disabled="true")
        .form-group
          .col-3.clom-sm-12
            label Policy for new users
          .col-9.col-sm-12
            z-switch
              .label-text Allow new users to create new corpora
              .label-hint If they cannot create new corpora, they can just comment existing corpora and navigate through them.
            z-switch Require manual approval of new users' new corpora
      .form-group
        .col-12
          z-button(v-on:click.native="editPreferencesGeneral" type="button" color="primary") {{ $t('save') }}
</template>

<script>
/* eslint-disable */
import { mapGetters, mapActions } from 'vuex'
import editPreferencesGeneralGql from '~/apollo/mutations/editPreferencesGeneral'
import { pick } from '~/utilities/objects'
import types from '~/assets/data/corpusTypes.js'

const wdk = require('wikidata-sdk')

export default {
  data() {
    return {
      general: {
        general_RegistrationAllowed: true,
        general_SiteDescription: '',
        general_SiteTitle: '',
        general_SiteTos: '',
        general_SiteRules: '',
        general_SiteSubjects: ''
      },
      subjects: [],
      subjectsSelected: [],
      isLoading: false
    }
  },
  computed: {
    ...mapGetters('instance', [
      'getInstanceName',
      'getInstanceDescription',
      'getOpenRegistrations',
      'getTerms',
      'getRules',
      'getInstanceSubjects'
    ]),
    subjectsAndTypes() {
      return [...this.subjects, ...types]
    }
  },
  mounted() {
    this.general.general_SiteTitle = this.getInstanceName
    this.general.general_SiteDescription = this.getInstanceDescription
    this.general.general_RegistrationAllowed = this.getOpenRegistrations
    this.general.general_SiteRules = this.getRules
    this.general.general_SiteTos = this.getTerms
    this.general.general_SiteSubjects = this.getInstanceSubjects

    if (this.getInstanceSubjects)
      this.subjectsSelected = this.getInstanceSubjects
  },
  methods: {
    ...mapActions('instance', ['syncNodeinfo']),
    editPreferencesGeneral() {
      this.$validator.validate().then(async valid => {
        try {
          if (!valid) {
            this.$toast.error('Your information still has formatting issues', {
              icon: 'warning'
            })
          } else {
            this.general.general_SiteSubjects = JSON.stringify(
              this.subjectsSelected
            )
            const res = await this.$apolloProvider.defaultClient
              .mutate({
                mutation: editPreferencesGeneralGql,
                variables: { input: this.general }
              })
              .then(({ data }) => data)
            if (res.editPreferencesGeneral) {
              this.$toast.success('Successfully changed site settings', {
                icon: 'check'
              })
              this.syncNodeinfo()
            } else {
              this.$toast.error('Some error occured', { icon: 'warning' })
            }
          }
        } catch (e) {
          console.log(e)
        }
      })
    },
    asyncFindTag(query) {
      if (!query) return
      this.isLoading = true
      fetch(wdk.searchEntities(query))
        .then(response => response.json())
        .then(data => {
          if (!data.search) return
          this.subjects = data.search.map(res => {
            return {
              ...pick(res, ['concepturi', 'description']),
              name: res.label,
              id: 'wikidata.org/entity/' + res.id
            }
          })
          this.isLoading = false
        })
        .catch(error => console.error(error))
    }
  },
  $_veeValidate: {
    validator: 'new'
  }
}
</script>

<style lang="postcss" scoped>
.form-group > div:nth-child(1) {
  text-align: right;
  padding-right: 20px;

  .input-group {
    justify-content: flex-end;
  }
}
.form-group label {
  cursor: default;
}
</style>
